﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PikcsörExcel
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            create_textBox();
            create_panel();
        }
        static int meret_x = 5; // a feladat szerint 5 oszlop van
        static int meret_y = 8; //a feladat szerint 8 sor van
        public TextBox[,] cella = new TextBox[meret_x, meret_y]; //a táblázat textboxokbóláll, melyeket dinamikusan hozunk létre a kódból
        public TextBox konzol_text; // a beviteli szövegdoboz
        public ListBox konzol_list; // a bevitel history-ja

        // a következő függvény a táblázat kirajzolásáért felelős
        public void create_textBox()
        {
            bool first = true; //kezdetben az első (a1) cella az aktív, melyet "Aqua" színnel jelölünk
            for (int i = 0; i < meret_x;i++ )
            {
                for (int k = 0; k < meret_y; k++)
                {
                    cella[i, k] = new TextBox();
                    cella[i, k].Name = "cella_"+i+k;
                    cella[i, k].Text = "";
                    cella[i, k].BackColor = Color.White;
                    cella[i, k].Size = new System.Drawing.Size(100, 20);
                    cella[i, k].TabIndex = 0;
                    cella[i, k].ReadOnly = true;
                    cella[i, k].BorderStyle = BorderStyle.FixedSingle;
                    cella[i, k].Location = new Point(((i*100)+20), ((k*20)+20) ); //oszloponként rajzolunk
                    if (first) { cella[i, k].BackColor = Color.Aqua; first = false; }
                    this.Controls.Add(cella[i, k]);
                }
            }
        }

        //A következő függvény az ablak inicializálásáért, a beviteli szövegdoboz megrajzolásáért, a history-t megjelenítő lista kirajzolásért felelős
        public void create_panel()
        {
            this.FormBorderStyle = FormBorderStyle.Fixed3D;
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(542, 473);
            this.Name = "Form1";
            this.Text = "PikcsőrExcel";
            this.ResumeLayout(false);

            konzol_text = new TextBox();
            konzol_text.Location = new System.Drawing.Point(20, this.Size.Height - 60);
            konzol_text.Name = "konzol_text";
            konzol_text.Size = new System.Drawing.Size(500, 20);
            konzol_text.TabIndex = 0;
            konzol_text.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.konzol_text_keypress); //A lényegi program belépési pontja
            this.Controls.Add(konzol_text);

            konzol_list = new ListBox();
            konzol_list.Location = new System.Drawing.Point(20, this.Size.Height - 80 - konzol_text.Height-200);
            konzol_list.Name = "konzol_list";
            konzol_list.Size = new System.Drawing.Size(500, 250);
            konzol_list.TabIndex = 0;
            this.Controls.Add(konzol_list);
        }


        //A bevitel megtörténik
        private void konzol_text_keypress(object sender, KeyPressEventArgs e)
        {
            if ((int)e.KeyChar == 13)
            {
                konzol_ertelmez(konzol_text.Text);
                konzol_text.Text = "";
            }
        }

        //Számon tartjuk, történt-e érvényes bevitel valamelyik cellába, hogy jelezni tudjuk ha mentés nélkül akarna kilépni a felhasználó.
        //Ezt a 'változott' logikai változó tárolja
        protected override void Dispose(bool disposing)
        {
            DialogResult dr = new DialogResult();
            dr = DialogResult.Yes;
            if (valtozott) dr = MessageBox.Show("Biztos ki akar lépni? Még nem mentette munkáját!", "PikcsőrExcel", MessageBoxButtons.YesNo);
            if (dr == DialogResult.Yes)
            {
                if (disposing && (components != null))
                {
                    components.Dispose();
                }
                base.Dispose(disposing);
            }
        }



        string[,] cella_keplet = new string[5, 8]; //elkülönítjük a képletet és a tényleges értéket. a tényleges érték az adott szövegdoboz 'Text' propertyjében tárolódik
        string[] parancsok = new string[3]; //3 függvény ismert:összeg, szorzat, hányados, ezeket tároljuk ebben a tömbben. Az ablak megnyitásakor töltjük fel értékekkel

        //Az éppen aktív cella koordinátái
        int aktiv_cella_oszlop = 0;
        int aktiv_cella_sor = 0;

        int tizedesjegyek = 2; // a cellaérték mindig kerekített. Ez a globális változó mondja meg hány jegyre. Később az 'F' paranccsal lényegében ennek a változónak az értékét lehet módosítani.
        bool valtozott = false;

        //A karakter értéke A = 65;

        
        //Kezdetben üresek a cellaértékek és a képletek is
        private void initize()
        {
            for (int i = 0; i < 5; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    cella_keplet[i, j] = "";
                }
            }
        }

        //A következő függvény értelmezi a beírt adatot, ami lehet szám, 1 betűs parancs vagy egy függvény
        private void konzol_ertelmez(string parancs)
        {
            string buffer = "";
            konzol_list.Items.Add((object)parancs); //A kiértékeléstől függetlenül a history-ba kerül a beírt információ

            //A feladat szerint a program nem érzékeny a kis- és nagybetűkre
            buffer = parancs.ToUpper()[0].ToString(); //az első karakter eldönti, hogy a 2 opció közül mi a bevitel
            parancs = parancs.ToUpper();
            int oszlop; int sor;


            switch (buffer)
            {
                case "G": //navigálás a cellák között
                    
                    buffer = parancs.Remove(0, 1);
                    buffer = buffer.Trim();
                    oszlop = cellaertelmezo(buffer)[0];
                    sor = cellaertelmezo(buffer)[1];

                    //vizálus cellaváltás
                    cella[aktiv_cella_oszlop, aktiv_cella_sor].BackColor = Color.White;
                    cella[oszlop, sor].BackColor = Color.Aqua; 

                    //Érdemi cellaváltás
                    aktiv_cella_oszlop = oszlop;
                    aktiv_cella_sor = sor;
                    break;

                case "S": //Mentés

                    buffer = parancs.Remove(0, 1);
                    buffer = buffer.Trim();
                    fajlkiiras(".\\" + buffer);
                    valtozott = false;
                    break;

                case "L": //proba.xlh betöltés

                    buffer = parancs.Remove(0, 1);
                    buffer = buffer.Trim();
                    fajlbeolvasas(".\\" + buffer);
                    frissito(); //a beolvasás nem értékel ki, ezért a képletbe tölt be. A frissítő az értékeket frissíti a képletek alapján

                    break;

                case "F": //Számformázás

                    buffer = parancs.Remove(0, 1);
                    buffer = buffer.Trim();
                    tizedesjegyek = Convert.ToInt32(buffer);
                    frissito(); //globálisan megmondtuk hány jegyre kell kerekíteni. Most az összes cella értékét ennek függvényében kell módosítani.
                    break;

                case "C": //Másolás

                    buffer = parancs.Remove(0, 1);
                    buffer = buffer.Trim();
                    int oszlop_1, oszlop_2;
                    int sor_1, sor_2;

                    //2 hely, 4 koordináta. Ezeket darabolással kapom meg
                    oszlop_1 = cellaertelmezo(buffer.Split(';')[0])[0];
                    sor_1 = cellaertelmezo(buffer.Split(';')[0])[1];
                    oszlop_2 = cellaertelmezo(buffer.Split(';')[1])[0];
                    sor_2 = cellaertelmezo(buffer.Split(';')[1])[1];

                    //2 helyre kell másolni:érték;képlet
                    cella[oszlop_2, sor_2].Text = cella[oszlop_1, sor_1].Text;
                    cella_keplet[oszlop_2, sor_2] = cella_keplet[oszlop_1, sor_1];
                    frissito();

                    break;

                case "Q": //Kilépés
                    Dispose();
                    break;

                case "=": //Függvény a bemenet, nem 1 betűs parancs
                    int hibakod; // a 'fuggvenyertelmezo' visstatérhet hibával
                    double eredmeny;
                    valtozott = true;
                    buffer = parancs.Remove(0, 1);

                    eredmeny = fuggvenyertelemzo(buffer, true, 1, out hibakod); //A függvény kiértékelése
                    if (hibakod == 0)
                    {
                        cella[aktiv_cella_oszlop, aktiv_cella_sor].Text = Convert.ToString(eredmeny); //Az érték tárolása
                    }
                    else cella[aktiv_cella_oszlop, aktiv_cella_sor].Text = "#HIBA:" + hibakod;
                    cella_keplet[aktiv_cella_oszlop, aktiv_cella_sor] = parancs; //A képlet tárolása

                    frissito();
                    break;

                default: //Se nem függvény, se nem egybetűs parancs => konkrét számérték
                    valtozott = true;
                    cella[aktiv_cella_oszlop, aktiv_cella_sor].Text = parancs;
                    cella_keplet[aktiv_cella_oszlop, aktiv_cella_sor] = parancs;
                    frissito();
                    break;
            }
        }

        //A következő függvény a megadott koordinátákat alakítja át a 2 dimenziós tömb értelmes indexértékeire
        //Oszlop: betűből szám, ahol A->0
        //Sor: 0-s index
        int[] cellaertelmezo(string cella_kord)
        {
            int oszlop; int sor;
            int[] kimenet = new int[2];
            int colnum = (int)(cella_kord.ToCharArray()[0]);
            oszlop = (int)(cella_kord.ToCharArray()[0]) - 65;
            sor = Convert.ToInt32(cella_kord.Remove(0, 1)) - 1;
            kimenet[0] = oszlop;
            kimenet[1] = sor;

            return kimenet;
        }

        //A következő függvény az értékeket frissíti a képletek alapján.
        void frissito()
        {
            bool[,] ell = new bool[5, 8];

            string buffer = "";
            int hibakod;
            double eredmeny;
            double result_full;

            //Számértékek frissítése kerekítéssel
            for (int i = 0; i < 5; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    if (cella_keplet[i, j] != "")
                    {
                        if (cella_keplet[i, j].ToCharArray()[0] != '=')
                        {
                            result_full = Convert.ToDouble(cella_keplet[i, j]);
                            result_full = result_full * Math.Pow(10, (double)tizedesjegyek);
                            result_full = (int)result_full;
                            result_full = result_full / Math.Pow(10, (double)tizedesjegyek);
                            cella[i, j].Text = Convert.ToString(result_full);
                            ell[i, j] = true;
                        }
                    }
                }
            }

            //Ha képlet függvény
            for (int sz = 0; sz < 10; sz++)
            {
                for (int i = 0; i < 5; i++)
                {
                    for (int j = 0; j < 8; j++)
                    {
                        if (ell[i, j] == false && cella_keplet[i,j] != "")
                        {

                            valtozott = true;
                            buffer = cella_keplet[i, j].Remove(0, 1);
                            eredmeny = fuggvenyertelemzo(buffer, true, 1, out hibakod);
                            if (hibakod == 0)
                            {
                                cella[i, j].Text = Convert.ToString(eredmeny);
                                ell[i, j] = true;
                            }
                            else cella[i, j].Text = "#HIBA:" + hibakod;

                        }
                    }
                }
                if (mind_igaz(ell)) break; //Mindent sikerült kiértékelni
            }


        }

        //Kétdimenziós logikai tömb értékeire ellenőrzi, hogy mind igaz-e
        bool mind_igaz(bool[,] bemenet)
        {
            bool result = true;

            for (int i = 0; i < 5; i++)
            {
                for (int j = 0; j < 5; j++)
                {
                    if (bemenet[i, j] == false) result = false;
                }
            }

            return result;
        }

        //Ha a bemenet függvény (azaz = jellel kezdődik), ez a függvény értékeli ki
        //Mivel lehet függvényeket egybeágyazni, ezért ez rekurzív függvény lesz. A 'szint' paraméter jelzi hányszor lett eddig meghívva
        double fuggvenyertelemzo(string fuggveny, bool indulo, int szint, out int hiba) //A függvény = jel nélkül kell
        {
            double result_full = 0; //A számolások eredményei
            fuggveny = fuggveny.TrimStart('(');
            
            double result = 0; //Ebben lesz az érték, amivel ténylegesen vissza fogunk térni.
            int hiba_be;
            int hiba_tortent = 0;
            string buffer = "";
            if (szint < 4) //Legfeljebb 3 függvény lehet egybeágyazva
            {
                try
                {
                    try
                    {
                        buffer = fuggveny.Remove(8); //Mi a külső függvény? Azért vágjuk le a 8. karaktertől, mert a leghosszabb függvény a 'Hányados' ami 8 karakter hosszú
                    }
                    catch (System.Exception)
                    {
                        buffer = fuggveny;
                    }
                    int i = 0;
                    for (i = 0; i < 3; i++)
                    {
                        if (buffer.Contains(parancsok[i])) break; //Menyi az első függvény? 0: Összeg; 1: Szorzat;2: Hányados
                    }

                    if (i == 0) //Összeg
                    {
                        int elso = fuggveny.IndexOf('(');
                        int utolso = fuggveny.LastIndexOf(')');
                        buffer = fuggveny.Remove(utolso);
                        buffer = buffer.Remove(0, elso + 1);
                        if (buffer.Contains(";")) //;-nél összeadom ami a karakter két oldalán van
                        {
                            //Nem biztos, hogy érték van a két oldalon, ezért mind a két oldalt újrakiértékeljük rekurzívan
                            result_full = fuggvenyertelemzo(buffer.Split(';')[0], false, szint + 1, out hiba_be) + fuggvenyertelemzo(buffer.Split(';')[1], false, szint + 1, out hiba_be);
                        }
                        else
                        {
                            if (buffer.Contains(":")) //:-nál egy tartomány értékeit kell összeadni
                            {
                                int oszlop_1, oszlop_2;
                                int sor_1, sor_2;

                                //A tartományt 2 koordináta jelöli. 2 koordináta, 4 érték
                                oszlop_1 = cellaertelmezo(buffer.Split(':')[0])[0];
                                sor_1 = cellaertelmezo(buffer.Split(':')[0])[1];
                                oszlop_2 = cellaertelmezo(buffer.Split(':')[1])[0];
                                sor_2 = cellaertelmezo(buffer.Split(':')[1])[1];

                                for (int j = oszlop_1; j <= oszlop_2; j++)
                                {
                                    for (int k = sor_1; k <= sor_2; k++)
                                    {
                                        result_full += Convert.ToDouble(cella[j, k].Text); //Összeadás, itt nem lehet, hogy még 1 függvény van
                                    }
                                }
                            }
                            else
                            {
                                hiba_tortent = 1;
                            }
                        }


                    }
                    if (i == 1) //Szorzat 
                    {
                        int elso = fuggveny.IndexOf('(');
                        int utolso = fuggveny.LastIndexOf(')');
                        buffer = fuggveny.Remove(utolso);
                        buffer = buffer.Remove(0, elso + 1);
                        result_full = 1;
                        if (buffer.Contains(";"))//;-nél összeadom ami a karakter két oldalán van
                        {
                            //Nem biztos, hogy érték van a két oldalon, ezért mind a két oldalt újrakiértékeljük rekurzívan
                            result_full = fuggvenyertelemzo(buffer.Split(';')[0], false, szint + 1, out hiba_be) * fuggvenyertelemzo(buffer.Split(';')[1], false, szint + 1, out hiba_be);
                        }
                        else
                        {
                            if (buffer.Contains(":"))//:-nál egy tartomány értékeit kell összeszorozni
                            {
                                int oszlop_1, oszlop_2;
                                int sor_1, sor_2;

                                //A tartományt 2 koordináta jelöli. 2 koordináta, 4 érték
                                oszlop_1 = cellaertelmezo(buffer.Split(':')[0])[0];
                                sor_1 = cellaertelmezo(buffer.Split(':')[0])[1];
                                oszlop_2 = cellaertelmezo(buffer.Split(':')[1])[0];
                                sor_2 = cellaertelmezo(buffer.Split(':')[1])[1];

                                for (int j = oszlop_1; j <= oszlop_2 ; j++)
                                {
                                    for (int k = sor_1; k <= sor_2; k++)
                                    {
                                        result_full *= Convert.ToDouble(cella[j, k].Text); //Szorzás, itt nem lehet, hogy még 1 függvény van
                                    }
                                }
                            }
                            else
                            {
                                hiba_tortent = 1;
                            }
                        }
                    }
                    if (i == 2) //Hányados
                    {
                        int elso = fuggveny.IndexOf('(');
                        int utolso = fuggveny.LastIndexOf(')');
                        buffer = fuggveny.Remove(utolso);
                        buffer = buffer.Remove(0, elso + 1);
                        if (buffer.Contains(";")) //A hányadosnál nem lehet tartomány, csak két érték, vagy függvény
                        {
                            if (buffer.Split(';')[1] != "0")
                            {
                                //Nem biztos, hogy érték van a két oldalon, ezért mind a két oldalt újrakiértékeljük rekurzívan
                                result_full = fuggvenyertelemzo(buffer.Split(';')[0], false, szint + 1, out hiba_be) / fuggvenyertelemzo(buffer.Split(';')[1], false, szint + 1, out hiba_be);
                            }
                            else
                            {
                                hiba_tortent = 1;
                            }

                        }
                        else
                        {
                            hiba_tortent = 1;
                        }


                    }
                    if (i == 3)
                    {
                        try
                        {
                            result_full = Convert.ToDouble(buffer);
                        }
                        catch (SystemException)
                        {
                            result_full = Convert.ToDouble(cella[cellaertelmezo(buffer)[0], cellaertelmezo(buffer)[1]].Text);
                        }
                    }

                }
                catch (SystemException)
                {
                    hiba_tortent = 1;
                }
            }
            else
            {
                hiba_tortent = 2;
            }
            if (indulo)
            {
                result_full = result_full * Math.Pow(10, (double)tizedesjegyek);
                result_full = (int)result_full;
                result_full = result_full / Math.Pow(10, (double)tizedesjegyek);
                result = result_full;
            }
            else
            {
                result = result_full;
            }

            hiba = hiba_tortent;
            return result;
        }

        //A következő eljárás a fájlbeolvasásért felel.
        private void fajlbeolvasas(string filename)
        {
            string[] osszefuggoszoveg = new string[8];//ide olvasom be a fajlt és ebből fogom megadni a "cella_keplet"-nek
            StreamReader sr = new StreamReader(filename+".xlh");
            // beolvasásnál 0-tól kezdve számolok, egy összefüggő szöveget fogok kapni(KÉPLET|KÉPLET...)
            for (int i = 0; i < 8; i++)
            {
                osszefuggoszoveg[i] = sr.ReadLine();
            }
            for (int i = 0; i < 8; i++)
            {
                for (int k = 0; k < 5; k++)
                {
                    try
                    {
                        cella_keplet[k, i] = osszefuggoszoveg[i].Split('|')[k];
                    }
                    catch
                    {
                        cella_keplet[k, i] = "";
                    }
                }
            }
            sr.Close();
        }

        //A következő eljárás a fájlkiírásért felel
        private void fajlkiiras(string nyariadbevalamit)
        {
            string buffer = ""; //Ebbe kerül bele 1 sor, amit majd ki kell írni (pipelinokkal, képletekkel)
            //cella[oszlop, sor].Text
            nyariadbevalamit += ".xlh";
            StreamWriter sw = new StreamWriter(nyariadbevalamit);
            for (int k = 0; k < 8; k++)
            {
                for (int i = 0; i < 5; i++)
                {
                    buffer += cella_keplet[i, k] + "|";

                }
                buffer = buffer.Remove(buffer.ToCharArray().Length - 1); //Az tuolsó után nincsen pipeline
                sw.WriteLine(buffer);
                buffer = null;
            }
            sw.Flush();
            sw.Close();
        }

        private void Form1_Load_1(object sender, EventArgs e)
        {
            parancsok[0] = "OSSZEG";
            parancsok[1] = "SZORZAT";
            parancsok[2] = "HANYADOS";
            initize();
            konzol_text.Focus();
        }
    } //CLASS Form1 END
} //NAMESPACE PikcsörExcel END
